-------------------------------------------------------------------------------------
-- | Namespace Definitions |---------------------------------------------------------
-------------------------------------------------------------------------------------

-- Retrieve the addon name (folder name) and the namespace table.
local addon, npcg = ...

local functua 	= npcg.functua
local stringLib = npcg.functua.string
local util 			= npcg.functua.util



function traitTemplate_OnLoad(self)
  self.Generator = function() return "" end
  self.ClearButton:SetScript(	"OnClick", function() self.EditBox:SetText("") end)
  --self.RollButton:SetScript(	"OnClick", function() self.EditBox:SetText(self.Generator()) end)
	self.SetTitle = function(self, title)
		self.Label:SetText(title)
	end
	self.GetValue = function() return self.EditBox:GetText()      end
  self.SetValue = function(x)       self.EditBox:SetText(x)     end
  
  self.DownVoteButton:SetScript("OnClick", function(self) npcg.tests.util.downVoteTrait(self:GetParent()["Label"]:GetText(), self:GetParent():GetValue()) end)
end

function traitTemplateExtraLong_OnLoad(self)
	self.SetTitle = function(self, title)
		self.Label:SetText(title)
	end
	self.GetValue = function(self, i) return self["EditBox"..i]:GetText() end
  
  self.DownVoteButton1:SetScript("OnClick", function(self) npcg.tests.util.downVoteTrait(self:GetParent()["Label"]:GetText() .. "1", self:GetParent():GetValue(1)) end)
  self.DownVoteButton2:SetScript("OnClick", function(self) npcg.tests.util.downVoteTrait(self:GetParent()["Label"]:GetText() .. "2", self:GetParent():GetValue(2)) end)
  self.DownVoteButton3:SetScript("OnClick", function(self) npcg.tests.util.downVoteTrait(self:GetParent()["Label"]:GetText() .. "3", self:GetParent():GetValue(3)) end)
end

function traitTemplate_OnShow(self)
  if NPCG_Options.debug == false then
    self.DownVoteButton:Hide()
  else
    self.DownVoteButton:Show()
  end
  
end

function traitTemplateExtraLong_OnShow(self)
  if NPCG_Options.debug == false then
    self.DownVoteButton1:Hide()
    self.DownVoteButton2:Hide()
    self.DownVoteButton3:Hide()
  else
    self.DownVoteButton1:Show()
    self.DownVoteButton2:Show()
    self.DownVoteButton3:Show()
  end

end