-------------------------------------------------------------------------------------
-- | Namespace Definitions |---------------------------------------------------------
-------------------------------------------------------------------------------------

-- Retrieve the addon name (folder name) and the namespace table.
local addon, npcg = ...

local functua 	= npcg.functua
local stringLib = npcg.functua.string
local util 			= npcg.functua.util

local voting = { }

npcg.tests.util = voting

-- Create NPCG_Testing namespaces.
if NPCG_Testing == nil then
  NPCG_Testing = { }
end

if NPCG_Testing.downVotedTraits == nil then
  NPCG_Testing.downVotedTraits = { }
end

if NPCG_Testing.downVotedNpcs == nil then
  NPCG_Testing.downVotedNpcs = { }
end

-------------------------------------------------------------------------------------
-- | Writing Traits to Test |--------------------------------------------------------
-------------------------------------------------------------------------------------

function voting.downVoteTrait(traitType, traitContent)
  table.insert(NPCG_Testing.downVotedTraits, { traitType, traitContent })
end

-------------------------------------------------------------------------------------
-- | Writing Npcs to Test |----------------------------------------------------------
-------------------------------------------------------------------------------------

function voting.downVoteNpc(npc)
  table.insert(NPCG_Testing.downVotedNpcs, npc)
end